import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.concurrent.*;

public class InvokeAll {

    public static void main(String[] args) {

        ExecutorService executorService = Executors.newSingleThreadExecutor();
        Set<Callable<String>> callables = new HashSet<Callable<String>>();

        callables.add(new Callable<String>() {
            public String call() throws Exception {
                return Thread.currentThread().getName() + " Task 1";
            }
        });
        callables.add(new Callable<String>() {
            public String call() throws Exception {
                return Thread.currentThread().getName() + " Task 2";
            }
        });
        callables.add(new Callable<String>() {
            public String call() throws Exception {
                return Thread.currentThread().getName() + " Task 3";
            }
        });


        try {
            List<Future<String>> result = executorService.invokeAll(callables); //Once of task is fully executed the other waiting task will get canceled
            for (Future<String> res : result) {
                System.out.println(res.get());
            }
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        } catch (ExecutionException e) {
            throw new RuntimeException(e);
        }

        executorService.shutdown();
    }
}
